<!--
  @File Name          : listeUserstory.html
  @Description        : 
  @Author             : ChangeMeIn@UserSettingsUnder.SFDoc
  @Group              : 
  @Last Modified By   : ChangeMeIn@UserSettingsUnder.SFDoc
  @Last Modified On   : 20/05/2020 à 22:49:48
  @Modification Log   : 
  Ver       Date            Author      		    Modification
  1.0    16/05/2020   ChangeMeIn@UserSettingsUnder.SFDoc     Initial Version
-->
<template>
    <center class="bienvenue" style="font-size: 188%;
    margin-block-start: 3%;
    font-family: cursive;
    font-style: italic;
    color: navy;">
      <p><b>Tableaux des User Story du Projet {DetailProjet.Name}</b></p><br/><br/>
      </center>
    <template if:true={openmodel}>
    <div class="demo-only">
        <section role="dialog" tabindex="-1" aria-labelledby="modal-heading-01" aria-modal="true" aria-describedby="modal-content-id-1" class="slds-modal slds-fade-in-open">
            <div class="slds-modal__container">
                <header class="slds-modal__header">
                    <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeModal}>
                        <lightning-icon icon-name="utility:close" size="medium">
                        </lightning-icon>
                        <span class="slds-assistive-text">Close</span>
                    </button>
                    <h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">Ajouter un User Story</h2>
                </header>
                <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">     
  <table>
    <tr>
      <td>
        <p>nom de Projet:</p>
      </td>
      <td>
        <lightning-input type="text" label=" "  required ="required"   value={DetailProjet.Name}  disabled ></lightning-input>
  
      </td>
    </tr>
  
    <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
    <TR></TR>
    <tr>
        <td>
          <p>nom de Sprint:</p>
        </td>
        <td>
          <lightning-input type="text" label=" "  required ="required"   value={detailSprint.Name}  disabled ></lightning-input>
    
        </td>
      </tr>
    
      <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
      <TR></TR>
      <tr>
        <td>
          <p>nom de User Story:</p>
        </td>
        <td>
          <lightning-input type="text" label=" " required ="required"  onchange={handleNameuserchange} value={UserStoryRecord.Name} placeholder="type here..."></lightning-input>
        </td>
      </tr>
  
      <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
      <TR></TR>
       <tr>
        <td>
          <p>Description:</p>
        </td>
        <td>
            <lightning-input type="text" label=" "  required ="required"  onchange={handleDescriptionchange} value={UserStoryRecord.Description__c}  placeholder="type here..."></lightning-input>
        </td>
      </tr> 
      <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
      <TR></TR>
      <tr>
        <td>
          <p>State:</p>
        </td>
        <td> 
          <lightning-combobox name="Etat__c" 
                  
          label=" " value={value} placeholder="-Select-"
          options={pickListvalues} onchange={handleetatchange}>
      </lightning-combobox>
        </td>
      </tr> 
     
    </table>
  </div>
  <footer class="slds-modal__footer">
      <lightning-button label="Annuler" variant="neutral" onclick={closeModal}></lightning-button>
      <lightning-button label="Enregistrer" variant="brand" onclick={saveMethod}></lightning-button>
  </footer>
  </div>
  </section>
  <div class="slds-backdrop slds-backdrop_open"></div>
  </div>
  
  </template>
  
    <div class="slds-modal__content slds-p-around_medium" style="margin-top: -4%;">
     <table><tr>
       <td><i>Nom de Projet:</i>  {DetailProjet.Name}</td>
       <td> <I>Categorie:</I>  {DetailProjet.Gat_gorie__c}</td>
       <td> <i>Etat:</i> {DetailProjet.Etat__c}  </td>
       <td> <i>Type:</i>   {DetailProjet.Type__c}  </td>
       <td><i>Priorité:</i>  {DetailProjet.Priorit__c}  </td>
       <td> <i>Date Debut:</i> {DetailProjet.Date_Debut__c}</td>
       <td><i>Date fin:</i> {DetailProjet.Date_fin__c}</td>
      </tr>
      </table>
  </div>
  <br/>
  <div class="slds-modal__content slds-p-around_medium" style="margin-top: -4%;">
    <table><tr>
      <td><i>Nom de Sprint:</i>  {detailSprint.Name}</td>
      <td> <I>Description:</I>  {detailSprint.Description__c }</td>
      <td> <i>Date Debut:</i> {detailSprint.Date_Debut__c}</td>
      <td><i>Date fin:</i> {detailSprint.Date_Fin__c}</td>
     </tr>
     </table>
 </div>
 <br/>
  <br/>
  <lightning-button class="btt_ajouter" icon-name="utility:add" label="Ajouter User Story" variant="brand" onclick={openmodal} ></lightning-button>
  <br/>
  
  <template if:true={verifbool}>
  <div class="slds-box slds-theme_default">
  <lightning-layout multiple-rows="true" horizontal-align="spread">
      <lightning-layout-item padding="horizontal-small" size="12">
      </lightning-layout-item>
      <lightning-layout-item padding="horizontal-small" size="2">
          <lightning-layout multiple-rows="true" >
              <lightning-layout-item size="12">
                  <lightning-card class="notStartedTasksLane">
                      <div slot="title">Not Started</div>
                  </lightning-card>
              </lightning-layout-item>
              <template if:true={verifbool}>
                  <template for:each={notStartedTasks} for:item="element">
                  <lightning-card icon-name="standard:task" key={element.Id}>
                      <div slot="title">Name: {element.Name}</div>
                      <div class="slds-card__body slds-card__body_inner">
                          <dl>
                              <dt>
                              <p key={element.Id}>Description: {element.Description__c}</p>
                              </dt>
                              <dt>
                                  <p key={element.Id}>Etat: {element.Etat__c}</p>
                              </dt>
                          </dl>
                      </div>
              
                      <div slot="actions" key={element.Id}>
                          <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                      </div>
                  </lightning-card>
              </template>
              </template>
          
          </lightning-layout>
      </lightning-layout-item>
  
      <lightning-layout-item padding="horizontal-small" size="2">
          <lightning-layout multiple-rows="true" >
              <lightning-layout-item size="12">
                  <lightning-card class="inProgressTasksLane">
                      <div slot="title">In Progress</div>
                  </lightning-card>
              </lightning-layout-item>
              <template if:true={verifbool}>
                  <template for:each={inProgressTasks} for:item="element">
                  <lightning-card icon-name="standard:task" key={element.Id}>
                      <div slot="title">Name: {element.Name}</div>
                      <div class="slds-card__body slds-card__body_inner">
                          <dl>
                              <dt>
                              <p key={element.Id}>Description: {element.Description__c}</p>
                              </dt>
                              <dt>
                                  <p key={element.Id}>Etat: {element.Etat__c}</p>
                              </dt>
                          </dl>
                      </div>
                      <div slot="actions" key={element.Id}>
                          <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                      </div>
                  </lightning-card>
              </template>
              </template>
          </lightning-layout>
      </lightning-layout-item>
  
      <lightning-layout-item padding="horizontal-small" size="2">
          <lightning-layout multiple-rows="true" >
              <lightning-layout-item size="12">
                  <lightning-card class="completedTasksLane">
                      <div slot="title">Completed</div>
                  </lightning-card>
              </lightning-layout-item>
              <template if:true={verifbool}>
              <template for:each={completedTasks} for:item="element">
                  
                  <lightning-card icon-name="standard:task" key={element.Id} >
                      <div slot="title">Name: {element.Name}</div>
                      <div class="slds-card__body slds-card__body_inner">
                          <dl>
                              <dt>
                              <p key={element.Id}>Description: {element.Description__c}</p>
                              </dt>
                              <dt>
                                  <p key={element.Id}>Etat: {element.Etat__c}</p>
                              </dt>
                          </dl>
                      </div>
                      <div slot="actions" key={element.Id}>
                          <p key={element.Id}> <lightning-button-icon icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon></p>
                      </div>
                  </lightning-card>
  
              </template>
              </template>
          </lightning-layout>
      </lightning-layout-item>
  
      <lightning-layout-item padding="horizontal-small" size="2">
          <lightning-layout multiple-rows="true" >
              <lightning-layout-item size="12">
                  <lightning-card class="deferredTasksLane">
                      <div slot="title">Deferred</div>
                  </lightning-card>
              </lightning-layout-item>
              <template if:true={verifbool}>
                  <template for:each={deferredTasks} for:item="element">
                  <lightning-card icon-name="standard:task" key={element.Id} style="width: 99%;">
                      <div slot="title">Name: {element.Name}</div>
                      <div class="slds-card__body slds-card__body_inner">
                          <dl>
                              <dt>
                              <p key={element.Id}>Description: {element.Description__c}</p>
                              </dt>
                              <dt>
                                  <p key={element.Id}>Etat: {element.Etat__c}</p>
                              </dt>
                          </dl>
                      </div>
                      <div slot="actions" key={element.Id}>
                          <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                      </div>
                  </lightning-card>
              </template>
              </template>
      </lightning-layout>
  </lightning-layout-item>
  </lightning-layout>
  </div> 
  </template>
  
  <!-- Spinner -->
  <div if:true={showLoadingSpinner}>
  <lightning-spinner alternative-text="Loading" size="large"></lightning-spinner>
  </div>
  
  
  <!-- Detail view modal -->
  <template if:true={bShowModal}>
  <section role="dialog" tabindex="-1"
          aria-labelledby="modal-heading-03"
          aria-modal="true"
          aria-describedby="modal-content-id-3"
          class="slds-modal slds-fade-in-open">
  <div class="slds-modal__container">
      <!-- modal header -->
      <header class="slds-modal__header">
          <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeModalAction}>
              <lightning-icon icon-name="utility:close" alternative-text="close" variant="inverse" size="small" ></lightning-icon>
          </button>
          
          <h2 id="modal-heading-03" class="slds-text-heading_medium slds-hyphenate" if:false={isEditForm}>Record Detail</h2>
          <h2 id="modal-heading-02" class="slds-text-heading_medium slds-hyphenate" if:true={isEditForm}>Update Record Values</h2>
      </header>
      <!-- modal body -->
      <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-3" if:false={isEditForm}>
          <dl class="slds-list_horizontal slds-wrap">
              <dt class="slds-item_label slds-truncate" title="Nom de Projet">Nom de Projet:</dt>
              <dd class="slds-item_detail slds-truncate">{DetailProjet.Name}</dd>
              <dt class="slds-item_label slds-truncate" title="Nom de Projet">Nom de Sprint</dt>
              <dd class="slds-item_detail slds-truncate">{detailSprint.Name}</dd>
              <dt class="slds-item_label slds-truncate" title="Nom de User Story">Nom de User Story:</dt>
              <dd class="slds-item_detail slds-truncate">{record.Name}</dd>
              <dt class="slds-item_label slds-truncate" title="Description">Description:</dt>
              <dd class="slds-item_detail slds-truncate">{record.Description__c}</dd>
              
              <dt class="slds-item_label slds-truncate" title="Description">Etat:</dt>
              <dd class="slds-item_detail slds-truncate">{record.Etat__c}</dd>
          </dl>
      </div>
      
      <!-- showing record edit form -->
      <div if:true={isEditForm} class="slds-theme_default">
          <lightning-record-edit-form layout-type="Full" record-id={currentRecordId} object-api-name="User_Story__c" onsubmit={handleSubmit} onsuccess={handleSuccess}>
              <lightning-messages></lightning-messages>
              <lightning-output-field field-name="Projet__c"></lightning-output-field>
              <lightning-output-field field-name="Sprint__c"></lightning-output-field>
              <lightning-input-field field-name="Name"></lightning-input-field>
              <lightning-input-field field-name="Description__c"></lightning-input-field>
              <lightning-input-field field-name="Etat__c"></lightning-input-field>
              <br/>
  
              <div style="text-align:center;">
                <lightning-button class="slds-m-top_small"
                                  variant="brand"
                                  type="submit"
                                  name="update"
                                  label="Update Record"></lightning-button>
            </div>
        </lightning-record-edit-form><br/>
      </div>
  
    <!-- modal footer start-->
    <footer class="slds-modal__footer" if:false={isEditForm}>
        <lightning-button variant="brand"
                          label="Close"
                          title="Close"
                          onclick={closeModalAction}></lightning-button>
    </footer>
  </div>
  </section>
  <div class="slds-backdrop slds-backdrop_open"></div>
  </template>
  <template if:true={data}>
    <lightning-datatable data={data}
                      columns={columns}
                  key-field="id"
                      hide-checkbox-column="true"
                      onrowaction={handleRowActions}></lightning-datatable>
  </template>
  </template>